Index: uspace/lib/c/include/offset.h
===================================================================
--- uspace/lib/c/include/offset.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/offset.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2017 Jakub Jermar 
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_OFFSET_H_
+#define LIBC_OFFSET_H_
+
+#include <stdint.h>
+
+/* off64_t */
+#define OFF64_MIN  INT64_MIN
+#define OFF64_MAX  INT64_MAX
+
+/* aoff64_t */
+#define AOFF64_MIN  UINT64_MIN
+#define AOFF64_MAX  UINT64_MAX
+
+/* off64_t, aoff64_t */
+#define PRIdOFF64 PRId64
+#define PRIuOFF64 PRIu64
+#define PRIxOFF64 PRIx64
+#define PRIXOFF64 PRIX64
+
+/** Relative offset */
+typedef int64_t off64_t;
+
+/** Absolute offset */
+typedef uint64_t aoff64_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/perm.h
===================================================================
--- uspace/lib/c/include/perm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/perm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIB_PERM_H_
+#define LIB_PERM_H_
+
+#include <task.h>
+
+extern int perm_grant(task_id_t, unsigned int);
+extern int perm_revoke(task_id_t, unsigned int);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/qsort.h
===================================================================
--- uspace/lib/c/include/qsort.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/qsort.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_QSORT_H_
+#define LIBC_QSORT_H_
+
+#include <stddef.h>
+
+extern void qsort(void *, size_t, size_t, int (*)(const void *,
+    const void *));
+extern void qsort_r(void *, size_t, size_t, int (*)(const void *,
+    const void *, void *), void *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/stack.h
===================================================================
--- uspace/lib/c/include/stack.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/stack.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_STACK_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 extern size_t stack_size_get(void);
Index: uspace/lib/c/include/stdbool.h
===================================================================
--- uspace/lib/c/include/stdbool.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define LIBC_BOOL_H_
 
-#include <libarch/types.h>
 #include <abi/bool.h>
 
Index: uspace/lib/c/include/stddef.h
===================================================================
--- uspace/lib/c/include/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,5 +42,6 @@
 #endif
 
-#define offsetof(type,member) ((size_t) &(((type *) 0)->member))
+#define offsetof(type, member) \
+	((size_t) &(((type *) 0)->member))
 
 #endif
Index: uspace/lib/c/include/stdint.h
===================================================================
--- uspace/lib/c/include/stdint.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/stdint.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -62,12 +62,4 @@
 #include <libarch/stdint.h>
 
-/* off64_t */
-#define OFF64_MIN  INT64_MIN
-#define OFF64_MAX  INT64_MAX
-
-/* aoff64_t */
-#define AOFF64_MIN  UINT64_MIN
-#define AOFF64_MAX  UINT64_MAX
-
 #endif
 
Index: uspace/lib/c/include/stdio.h
===================================================================
--- uspace/lib/c/include/stdio.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/stdio.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define LIBC_STDIO_H_
 
-#include <sys/types.h>
 #include <stdarg.h>
 #include <str.h>
@@ -140,7 +139,7 @@
 extern size_t fwrite(const void *, size_t, size_t, FILE *);
 
-extern int fseek(FILE *, off64_t, int);
+extern int fseek(FILE *, long, int);
 extern void rewind(FILE *);
-extern off64_t ftell(FILE *);
+extern long ftell(FILE *);
 extern int feof(FILE *);
 extern int fileno(FILE *);
Index: uspace/lib/c/include/stdlib.h
===================================================================
--- uspace/lib/c/include/stdlib.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/stdlib.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 
 #include <malloc.h>
+#include <qsort.h>
 #include <stacktrace.h>
 
Index: uspace/lib/c/include/str.h
===================================================================
--- uspace/lib/c/include/str.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/str.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -99,4 +99,5 @@
 extern int utf16_to_str(char *dest, size_t size, const uint16_t *src);
 extern int str_to_utf16(uint16_t *dest, size_t dlen, const char *src);
+extern size_t utf16_wsize(const uint16_t *ustr);
 
 extern char *str_chr(const char *str, wchar_t ch);
Index: uspace/lib/c/include/syscall.h
===================================================================
--- uspace/lib/c/include/syscall.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/syscall.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,5 +45,5 @@
 
 #include <abi/syscall.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define __syscall0  __syscall
Index: uspace/lib/c/include/sysinfo.h
===================================================================
--- uspace/lib/c/include/sysinfo.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/sysinfo.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define LIBC_SYSINFO_H_
 
+#include <types/common.h>
 #include <stddef.h>
 #include <stdbool.h>
Index: uspace/lib/c/include/types/common.h
===================================================================
--- uspace/lib/c/include/types/common.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/types/common.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2017 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_TYPES_COMMON_H_
+#define LIBC_TYPES_COMMON_H_
+
+#include <libarch/types.h>
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/types/label.h
===================================================================
--- uspace/lib/c/include/types/label.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/types/label.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -124,4 +124,6 @@
 } label_pcnt_t;
 
+#define LPC_LIMIT (lpc_minix + 1)
+
 #endif
 
Index: uspace/lib/c/include/types/vol.h
===================================================================
--- uspace/lib/c/include/types/vol.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/types/vol.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,6 @@
 
 #include <async.h>
+#include <ipc/vol.h>
+#include <stdbool.h>
 
 typedef enum {
@@ -71,5 +73,13 @@
 	/** Filesystem type */
 	vol_fstype_t fstype;
+	/** Volume label */
+	char label[VOL_LABEL_MAXLEN + 1];
 } vol_part_info_t;
+
+/** Volume label support */
+typedef struct {
+	/** Volume labels are supported */
+	bool supported;
+} vol_label_supp_t;
 
 #endif
Index: uspace/lib/c/include/unaligned.h
===================================================================
--- uspace/lib/c/include/unaligned.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/unaligned.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2017 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_UNALIGNED_H_
+#define LIBC_UNALIGNED_H_
+
+#include <stdint.h>
+
+typedef int16_t unaligned_int16_t __attribute__ ((aligned(1)));
+typedef int32_t unaligned_int32_t __attribute__ ((aligned(1)));
+typedef int64_t unaligned_int64_t __attribute__ ((aligned(1)));
+
+typedef uint16_t unaligned_uint16_t __attribute__ ((aligned(1)));
+typedef uint32_t unaligned_uint32_t __attribute__ ((aligned(1)));
+typedef uint64_t unaligned_uint64_t __attribute__ ((aligned(1)));
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/vbd.h
===================================================================
--- uspace/lib/c/include/vbd.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/vbd.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
 #include <loc.h>
 #include <types/label.h>
-#include <sys/types.h>
+#include <offset.h>
 
 /** VBD service */
Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/vfs/vfs.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,4 +43,5 @@
 #include <stdio.h>
 #include <async.h>
+#include <offset.h>
 
 #define MAX_OPEN_FILES	128
Index: uspace/lib/c/include/vol.h
===================================================================
--- uspace/lib/c/include/vol.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/vol.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,5 +48,6 @@
 extern int vol_part_info(vol_t *, service_id_t, vol_part_info_t *);
 extern int vol_part_empty(vol_t *, service_id_t);
-extern int vol_part_mkfs(vol_t *, service_id_t, vol_fstype_t);
+extern int vol_part_get_lsupp(vol_t *, vol_fstype_t, vol_label_supp_t *);
+extern int vol_part_mkfs(vol_t *, service_id_t, vol_fstype_t, const char *);
 
 #endif
Index: uspace/lib/c/test/fibril/timer.c
===================================================================
--- uspace/lib/c/test/fibril/timer.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/test/fibril/timer.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,140 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <fibril_synch.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(fibril_timer);
+
+static void test_timeout_fn(void *arg)
+{
+	int *i;
+
+	i = (int *)arg;
+	++*i;
+}
+
+PCUT_TEST(create_destroy)
+{
+	fibril_timer_t *t;
+
+	t = fibril_timer_create(NULL);
+	PCUT_ASSERT_NOT_NULL(t);
+	fibril_timer_destroy(t);
+}
+
+PCUT_TEST(create_destroy_user_lock)
+{
+	fibril_mutex_t lock;
+	fibril_timer_t *t;
+
+	fibril_mutex_initialize(&lock);
+	t = fibril_timer_create(&lock);
+	PCUT_ASSERT_NOT_NULL(t);
+	fibril_timer_destroy(t);
+}
+
+PCUT_TEST(set_clear_locked)
+{
+	fibril_mutex_t lock;
+	fibril_timer_t *t;
+	fibril_timer_state_t fts;
+	int cnt;
+
+	fibril_mutex_initialize(&lock);
+	t = fibril_timer_create(&lock);
+	PCUT_ASSERT_NOT_NULL(t);
+
+	fibril_mutex_lock(&lock);
+	cnt = 0;
+
+	fibril_timer_set_locked(t, 100 * 1000 * 1000, test_timeout_fn, &cnt);
+	fibril_usleep(1000);
+	fts = fibril_timer_clear_locked(t);
+	PCUT_ASSERT_INT_EQUALS(fts_active, fts);
+
+	PCUT_ASSERT_INT_EQUALS(0, cnt);
+	fibril_mutex_unlock(&lock);
+
+	fibril_timer_destroy(t);
+}
+
+PCUT_TEST(set_clear_not_locked)
+{
+	fibril_mutex_t lock;
+	fibril_timer_t *t;
+	fibril_timer_state_t fts;
+	int cnt;
+
+	fibril_mutex_initialize(&lock);
+	t = fibril_timer_create(&lock);
+	PCUT_ASSERT_NOT_NULL(t);
+
+	cnt = 0;
+	fibril_timer_set(t, 100 * 1000 * 1000, test_timeout_fn, &cnt);
+	fibril_usleep(1000);
+	fts = fibril_timer_clear(t);
+	PCUT_ASSERT_INT_EQUALS(fts_active, fts);
+
+	PCUT_ASSERT_INT_EQUALS(0, cnt);
+
+	fibril_timer_destroy(t);
+}
+
+PCUT_TEST(fire)
+{
+	fibril_mutex_t lock;
+	fibril_timer_t *t;
+	fibril_timer_state_t fts;
+	int cnt;
+
+	fibril_mutex_initialize(&lock);
+	t = fibril_timer_create(&lock);
+	PCUT_ASSERT_NOT_NULL(t);
+
+	fibril_mutex_lock(&lock);
+	cnt = 0;
+
+	fibril_timer_set_locked(t, 100, test_timeout_fn, &cnt);
+	fibril_mutex_unlock(&lock);
+
+	fibril_usleep(1000);
+
+	fibril_mutex_lock(&lock);
+	fts = fibril_timer_clear_locked(t);
+	PCUT_ASSERT_INT_EQUALS(fts_fired, fts);
+
+	PCUT_ASSERT_INT_EQUALS(1, cnt);
+	fibril_mutex_unlock(&lock);
+
+	fibril_timer_destroy(t);
+}
+
+PCUT_EXPORT(fibril_timer);
Index: uspace/lib/c/test/io/table.c
===================================================================
--- uspace/lib/c/test/io/table.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/test/io/table.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <io/table.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(table);
+
+PCUT_TEST(smoke) {
+	table_t *table;
+	int rc;
+
+	rc = table_create(&table);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	table_header_row(table);
+	rc = table_printf(table, "A\t" "B\t" "C\t" "D\n");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = table_printf(table, "1\t" "2\t" "3\t" "4\n");
+	rc = table_printf(table, "i\t" "ii\t" "iii\t" "iv\n");
+	table_destroy(table);
+}
+
+PCUT_EXPORT(table);
Index: uspace/lib/c/test/main.c
===================================================================
--- uspace/lib/c/test/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/test/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -32,7 +32,10 @@
 PCUT_INIT
 
+PCUT_IMPORT(fibril_timer);
 PCUT_IMPORT(odict);
+PCUT_IMPORT(qsort);
 PCUT_IMPORT(sprintf);
 PCUT_IMPORT(str);
+PCUT_IMPORT(table);
 
 PCUT_MAIN()
Index: uspace/lib/c/test/odict.c
===================================================================
--- uspace/lib/c/test/odict.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/test/odict.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -272,5 +272,4 @@
 
 		v = seq_next(v);
-		++i;
 	}
 }
Index: uspace/lib/c/test/qsort.c
===================================================================
--- uspace/lib/c/test/qsort.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/test/qsort.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,174 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+#include <qsort.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+enum {
+	/** Length of test number sequences */
+	test_seq_len = 5
+};
+
+/** Test compare function.
+ *
+ * @param a First key
+ * @param b Second key
+ * @return <0, 0, >0 if @a a is less than, equal or greater than @a b
+ */
+static int test_cmp(const void *a, const void *b)
+{
+	int *ia = (int *)a;
+	int *ib = (int *)b;
+
+	return *ia - *ib;
+}
+
+static void bubble_sort(int *seq, size_t nmemb)
+{
+	size_t i;
+	size_t j;
+	int t;
+
+	for (i = 0; i < nmemb - 1; i++)
+		for (j = 0; j < nmemb - 1; j++) {
+			if (seq[j] > seq[j + 1]) {
+				t = seq[j];
+				seq[j] = seq[j + 1];
+				seq[j + 1] = t;
+			}
+		}
+}
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(qsort);
+
+/** Test sorting already sorted increasing sequence */
+PCUT_TEST(incr_seq)
+{
+	int *seq;
+	int i;
+
+	seq = calloc(test_seq_len, sizeof(int));
+	PCUT_ASSERT_NOT_NULL(seq);
+
+	for (i = 0; i < test_seq_len; i++)
+		seq[i] = i;
+
+	qsort(seq, test_seq_len, sizeof(int), test_cmp);
+
+	for (i = 0; i < test_seq_len; i++) {
+		PCUT_ASSERT_INT_EQUALS(i, seq[i]);
+	}
+
+	free(seq);
+}
+
+/** Test sorting reverse-sorted decreasing sequence. */
+PCUT_TEST(decr_seq)
+{
+	int *seq;
+	int i;
+
+	seq = calloc(test_seq_len, sizeof(int));
+	PCUT_ASSERT_NOT_NULL(seq);
+
+	for (i = 0; i < test_seq_len; i++)
+		seq[i] = test_seq_len - 1 - i;
+
+	qsort(seq, test_seq_len, sizeof(int), test_cmp);
+
+	for (i = 0; i < test_seq_len; i++) {
+		PCUT_ASSERT_INT_EQUALS(i, seq[i]);
+	}
+
+	free(seq);
+}
+
+/** Test sorting reverse-sorted decreasing sequence where each member repeats twice. */
+PCUT_TEST(decr2_seq)
+{
+	int *seq;
+	int i;
+
+	seq = calloc(test_seq_len, sizeof(int));
+	PCUT_ASSERT_NOT_NULL(seq);
+
+	for (i = 0; i < test_seq_len; i++) {
+		seq[i] = (test_seq_len - 1 - i) / 2;
+	}
+
+	qsort(seq, test_seq_len, sizeof(int), test_cmp);
+
+	for (i = 0; i < test_seq_len; i++) {
+		PCUT_ASSERT_INT_EQUALS(i / 2, seq[i]);
+	}
+
+	free(seq);
+}
+
+/** Generate pseudorandom sequence. */
+static int seq_next(int cur)
+{
+	return (cur * 1951) % 1000000;
+}
+
+/** Test sorting pseudorandom sequence. */
+PCUT_TEST(pseudorandom_seq)
+{
+	int *seq, *seq2;
+	int i;
+	int v;
+
+	seq = calloc(test_seq_len, sizeof(int));
+	PCUT_ASSERT_NOT_NULL(seq);
+
+	seq2 = calloc(test_seq_len, sizeof(int));
+	PCUT_ASSERT_NOT_NULL(seq);
+
+	v = 1;
+	for (i = 0; i < test_seq_len; i++) {
+		seq[i] = v;
+		seq2[i] = v;
+		v = seq_next(v);
+	}
+
+	qsort(seq, test_seq_len, sizeof(int), test_cmp);
+	bubble_sort(seq2, test_seq_len);
+
+	for (i = 0; i < test_seq_len; i++) {
+		PCUT_ASSERT_INT_EQUALS(seq2[i], seq[i]);
+	}
+
+	free(seq);
+	free(seq2);
+}
+
+PCUT_EXPORT(qsort);
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/clui/tinput.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,5 +27,4 @@
  */
 
-#include <sort.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -583,5 +582,5 @@
 
 /** Compare two entries in array of completions. */
-static int compl_cmp(void *va, void *vb, void *arg)
+static int compl_cmp(const void *va, const void *vb)
 {
 	const char *a = *(const char **) va;
@@ -741,5 +740,5 @@
 			/* No common prefix. Sort and display all entries. */
 
-			qsort(compl, cnum, sizeof(char *), compl_cmp, NULL);
+			qsort(compl, cnum, sizeof(char *), compl_cmp);
 
 			tinput_jump_after(ti);
Index: uspace/lib/draw/codec/webp.c
===================================================================
--- uspace/lib/draw/codec/webp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/draw/codec/webp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
 #include <stdbool.h>
 #include <pixconv.h>
-#include <sys/types.h>
+#include <fourcc.h>
 #include <stdint.h>
 #include <abi/fourcc.h>
Index: uspace/lib/draw/font/pcf.c
===================================================================
--- uspace/lib/draw/font/pcf.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/draw/font/pcf.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,4 +41,5 @@
 #include <stdio.h>
 #include <align.h>
+#include <offset.h>
 
 #include "pcf.h"
Index: uspace/lib/draw/path.c
===================================================================
--- uspace/lib/draw/path.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/draw/path.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,5 +35,4 @@
 
 #include <assert.h>
-#include <stdbool.h>
 #include <malloc.h>
 
